// Copyright (c) 2018-present by Michael Herwig <michael.herwig@hotmail.de>
// All rights reserved.

#include <gmock/gmock.h>

#include <map>
#include <string>

#include <Xi/Crypto/Hash/Sha3.hh>

#include "OracleTest.hpp"

#define XI_TEST_SUITE Xi_Crypto_Hash_Sha3

TEST(XI_TEST_SUITE, Hash224) {
  using Hash = Xi::Crypto::Hash::Sha3::Hash224;
  static const std::vector<std::pair<std::string, Hash>> Oracle{{

      {"",
       Hash{{0x6b, 0x4e, 0x03, 0x42, 0x36, 0x67, 0xdb, 0xb7, 0x3b, 0x6e, 0x15, 0x45, 0x4f, 0x0e,
             0xb1, 0xab, 0xd4, 0x59, 0x7f, 0x9a, 0x1b, 0x07, 0x8e, 0x3f, 0x5b, 0x5a, 0x6b, 0xc7}}},
      {"iu6QiD1lpH",
       Hash{{0xdb, 0x0d, 0x9c, 0x72, 0xc6, 0x65, 0x73, 0xc3, 0x56, 0x63, 0x5b, 0x74, 0x88, 0xd1,
             0x9e, 0xf6, 0x6a, 0x0a, 0xbf, 0x3d, 0xe6, 0x85, 0xb1, 0x06, 0x58, 0x54, 0xd1, 0x46}}},
      {"oPY1ZcUoPL",
       Hash{{0x52, 0x09, 0xc7, 0x87, 0x57, 0x4f, 0x53, 0x2d, 0xa7, 0x40, 0x92, 0xf3, 0x77, 0x34,
             0xf2, 0xa5, 0x79, 0xab, 0xbd, 0xf9, 0x85, 0xf6, 0xec, 0xbb, 0x78, 0x2c, 0x95, 0x77}}},
      {"BXHHILmBXf",
       Hash{{0x72, 0x98, 0x37, 0xe6, 0xe7, 0x28, 0xd2, 0x8e, 0xad, 0x2d, 0x20, 0x5e, 0x61, 0x00,
             0xfc, 0xaf, 0x99, 0x1a, 0xf8, 0x00, 0xef, 0x0f, 0x2d, 0x47, 0x5b, 0x1c, 0x71, 0x98}}}

  }};
  XiCryptoTest::genericHashTest<Hash>(Oracle);
}

TEST(XI_TEST_SUITE, Hash256) {
  using Hash = Xi::Crypto::Hash::Sha3::Hash256;
  static const std::vector<std::pair<std::string, Hash>> Oracle{{

      {"", Hash{{0xa7, 0xff, 0xc6, 0xf8, 0xbf, 0x1e, 0xd7, 0x66, 0x51, 0xc1, 0x47,
                 0x56, 0xa0, 0x61, 0xd6, 0x62, 0xf5, 0x80, 0xff, 0x4d, 0xe4, 0x3b,
                 0x49, 0xfa, 0x82, 0xd8, 0x0a, 0x4b, 0x80, 0xf8, 0x43, 0x4a}}},
      {"iu6QiD1lpH", Hash{{0xce, 0xba, 0xca, 0x3e, 0x92, 0x9e, 0x21, 0xbc, 0xd7, 0xc3, 0x59,
                           0xe4, 0x4f, 0xab, 0x4f, 0x8e, 0x87, 0x0a, 0xc6, 0x00, 0xc0, 0xaf,
                           0x88, 0x85, 0x82, 0xb8, 0x09, 0x8b, 0x3f, 0xdc, 0x78, 0x5d}}},
      {"oPY1ZcUoPL", Hash{{0x25, 0xe0, 0xd1, 0xda, 0x4f, 0xfe, 0x1a, 0x5b, 0x4a, 0x0e, 0x58,
                           0xa2, 0x99, 0x5a, 0xb9, 0x4c, 0x57, 0x4c, 0xa7, 0x5f, 0x3d, 0x98,
                           0x98, 0xbd, 0x29, 0x03, 0xa0, 0xae, 0x17, 0xa6, 0x54, 0x8c}}},
      {"BXHHILmBXf", Hash{{0x1a, 0x4d, 0xb6, 0x64, 0xe8, 0xcf, 0x83, 0xad, 0xee, 0x4e, 0x2b,
                           0xc3, 0xa9, 0xe6, 0x10, 0x54, 0x0a, 0x7e, 0xfd, 0xf8, 0x41, 0x90,
                           0x2a, 0x1b, 0x49, 0xe3, 0x41, 0xb6, 0x4d, 0xae, 0xad, 0x75}}},

  }};
  XiCryptoTest::genericHashTest<Hash>(Oracle);
}

TEST(XI_TEST_SUITE, Hash384) {
  using Hash = Xi::Crypto::Hash::Sha3::Hash384;
  static const std::vector<std::pair<std::string, Hash>> Oracle{{

      {"", Hash{{0x0c, 0x63, 0xa7, 0x5b, 0x84, 0x5e, 0x4f, 0x7d, 0x01, 0x10, 0x7d, 0x85,
                 0x2e, 0x4c, 0x24, 0x85, 0xc5, 0x1a, 0x50, 0xaa, 0xaa, 0x94, 0xfc, 0x61,
                 0x99, 0x5e, 0x71, 0xbb, 0xee, 0x98, 0x3a, 0x2a, 0xc3, 0x71, 0x38, 0x31,
                 0x26, 0x4a, 0xdb, 0x47, 0xfb, 0x6b, 0xd1, 0xe0, 0x58, 0xd5, 0xf0, 0x04}}},
      {"iu6QiD1lpH",
       Hash{{0xc8, 0xe3, 0x3c, 0x8e, 0xe6, 0x9b, 0x2f, 0x91, 0xf0, 0xca, 0x67, 0xc4,
             0xeb, 0x98, 0xac, 0x3c, 0x54, 0xd7, 0xa0, 0x13, 0xb6, 0x09, 0x01, 0xcc,
             0xca, 0x74, 0xa6, 0x4f, 0xb0, 0xa9, 0x46, 0x89, 0x93, 0x66, 0x4a, 0xa1,
             0x61, 0xec, 0xd5, 0x11, 0xc2, 0x44, 0xda, 0x7d, 0x4f, 0x17, 0x92, 0x10}}},
      {"oPY1ZcUoPL",
       Hash{{0x9e, 0xf2, 0xb3, 0xc6, 0x30, 0xc9, 0xae, 0xeb, 0xa4, 0xdd, 0xc2, 0x3b,
             0x43, 0x1c, 0x17, 0xe4, 0x88, 0x3e, 0xaf, 0xe3, 0x25, 0xa1, 0x39, 0x9e,
             0x06, 0x3c, 0x8d, 0x6d, 0x50, 0x77, 0xea, 0x22, 0x8b, 0xf9, 0xd4, 0x07,
             0x58, 0x8e, 0x35, 0x00, 0xc2, 0xdc, 0x19, 0x4a, 0x64, 0x2b, 0xe2, 0x08}}},
      {"BXHHILmBXf",
       Hash{{0xd8, 0x06, 0xb0, 0x49, 0xe7, 0xcd, 0x3a, 0x81, 0xd0, 0x3c, 0x53, 0xd7,
             0xd4, 0x01, 0x55, 0x58, 0x2d, 0x4f, 0xe1, 0x38, 0x95, 0x13, 0xc1, 0xdc,
             0x99, 0x02, 0x52, 0x6e, 0xe8, 0xaa, 0x4c, 0x21, 0xb0, 0x61, 0x39, 0x9d,
             0x00, 0x56, 0xc4, 0xb0, 0x1e, 0x04, 0xc2, 0xff, 0x08, 0x76, 0x19, 0x92}}},

  }};
  XiCryptoTest::genericHashTest<Hash>(Oracle);
}

TEST(XI_TEST_SUITE, Hash512) {
  using Hash = Xi::Crypto::Hash::Sha3::Hash512;
  static const std::vector<std::pair<std::string, Hash>> Oracle{{

      {"", Hash{{0xa6, 0x9f, 0x73, 0xcc, 0xa2, 0x3a, 0x9a, 0xc5, 0xc8, 0xb5, 0x67, 0xdc, 0x18,
                 0x5a, 0x75, 0x6e, 0x97, 0xc9, 0x82, 0x16, 0x4f, 0xe2, 0x58, 0x59, 0xe0, 0xd1,
                 0xdc, 0xc1, 0x47, 0x5c, 0x80, 0xa6, 0x15, 0xb2, 0x12, 0x3a, 0xf1, 0xf5, 0xf9,
                 0x4c, 0x11, 0xe3, 0xe9, 0x40, 0x2c, 0x3a, 0xc5, 0x58, 0xf5, 0x00, 0x19, 0x9d,
                 0x95, 0xb6, 0xd3, 0xe3, 0x01, 0x75, 0x85, 0x86, 0x28, 0x1d, 0xcd, 0x26}}},
      {"iu6QiD1lpH",
       Hash{{0x6f, 0x90, 0x02, 0xb9, 0xd4, 0x13, 0x8c, 0xce, 0x32, 0x17, 0xd6, 0x25, 0x8f,
             0xd6, 0xe9, 0xa7, 0xbe, 0x93, 0x28, 0xc2, 0xf6, 0x2a, 0x65, 0xab, 0x14, 0xf6,
             0x73, 0x81, 0x46, 0x58, 0xff, 0x50, 0xc8, 0x68, 0x00, 0x49, 0xb9, 0x64, 0x4b,
             0xa9, 0xd7, 0x74, 0xa0, 0x8d, 0x5d, 0x01, 0xb0, 0x9f, 0x11, 0x10, 0x3a, 0x45,
             0xf4, 0x2a, 0x40, 0xed, 0xa5, 0xea, 0xcc, 0xe9, 0x16, 0x78, 0x2a, 0xdb}}},
      {"oPY1ZcUoPL",
       Hash{{0x05, 0xf0, 0x74, 0x11, 0x8c, 0x04, 0x48, 0x99, 0x68, 0x00, 0xbe, 0xfd, 0xa9,
             0x76, 0x00, 0x55, 0xdd, 0x18, 0x43, 0xe0, 0x4f, 0x00, 0x21, 0x5a, 0x1b, 0xd2,
             0x56, 0x12, 0x6c, 0xfb, 0x4d, 0x66, 0x9c, 0x42, 0x09, 0x4d, 0x7d, 0x8e, 0x7f,
             0xa3, 0x9f, 0x48, 0x40, 0xb2, 0xe8, 0x26, 0x39, 0xa3, 0x9e, 0xa1, 0xcc, 0x8a,
             0xe9, 0x2d, 0x7f, 0x82, 0xa3, 0x51, 0x25, 0x3b, 0xd5, 0xae, 0x32, 0xe1}}},
      {"BXHHILmBXf",
       Hash{{0x4f, 0xc3, 0x10, 0xbc, 0x9e, 0x6c, 0x7d, 0x84, 0xf4, 0x29, 0x0b, 0xc8, 0x26,
             0x26, 0xe8, 0x5e, 0x0f, 0x1c, 0xed, 0x02, 0xd1, 0x3b, 0x82, 0x72, 0xe8, 0x17,
             0xe1, 0xa6, 0xd7, 0x1b, 0xd7, 0x7a, 0x50, 0xe2, 0xc1, 0x6e, 0xc1, 0xa9, 0x7e,
             0x4e, 0xeb, 0x97, 0x5a, 0x6e, 0xd2, 0x5e, 0x70, 0x86, 0x49, 0xec, 0x59, 0x4e,
             0xd3, 0xfb, 0xc5, 0x43, 0xe4, 0x9b, 0x92, 0xfd, 0xe2, 0xfb, 0x55, 0xd9}}},

  }};
  XiCryptoTest::genericHashTest<Hash>(Oracle);
}
